#ifndef COLOR_H
#define COLOR_H

struct tRGBA
{
	tRGBA(float r = -1, float g = -1, float b = -1, float a = -1) : R(r), G(g), B(b), A(a) { }

	union
	{
		struct
		{
			float R;	/*!< Red channel value */
			float G;	/*!< Green channel value */
			float B;	/*!< Blue channel value */
			float A;	/*!< Alpha value */
		};
		
		float RGBA[4];
	};
		float operator[] (UINT i)
		{
			if(i >=0 && i< 4)
				return RGBA[i];

			return 0;
		};

};

#endif