#ifndef COMMON_H
#define COMMON_H

#pragma once

#include "Config.h"

#include "Singleton.h"
#include "Logger.h"
#include "DoubleList.h"
#include "CommonDefs.h"
#include "CommonStructs.h"
#include "Timer.h"

int roundf(float val);

#include <CString>
using namespace std;

enum eEntityType
{
	Entity_Default,
	Entity_Texture,
	Entity_OpenGLTexture,
	Entity_Material,
	Entity_OpenGLMaterial,
	Entity_Animation,
	Entity_FrameAnimation,
	Entity_TextureFrameAnimation,
	Entity_CustomFont,
	Entity_BitmapFont,
	Entity_Resource,
	Entity_XMLResource,

	Entity_InputEngine,


	Entity_GUIElement,
	Entity_GUIBorder,
	Entity_GUIStatic,
	Entity_GUITextBox,
	Entity_GUIButton,
	Entity_GUIRadioGroup,
	Entity_GUIDropList,
	Entity_GUIListBox,
	Entity_GUITabControl,
	Entity_GUIScrollBar,
	Entity_GUIProgressBar,
	Entity_GUIMenuEntry,
	Entity_GUIMenu,
    Entity_GUIWindow,
    Entity_GUI,

	Entity_ResourceManager,
	Entity_TextureManager,
	Entity_MaterialManager,
	Entity_FontManager,
	Entity_AnimationManager,
	
	Entity_InputDevice,
	Entity_Keyboard,
	Entity_Mouse,
	Entity_Joystick,
	Entity_GamePad
};

#endif