#include "KeyboardState.h"

CKeyboardState::CKeyboardState()
{
	m_uipKeys = new UINT[256];
	m_uiKeyCount = 256;
}

CKeyboardState::~CKeyboardState()
{
	Destroy();
}

UINT CKeyboardState::Poll()
{
	#ifndef DIRECT_INPUT
		GetKeyboardState((BYTE *)m_uipKeys);
	#else
		if(m_pDIDevice == NULL)
		{
			HRESULT Result = g_pDI->CreateDevice(GUID_SysKeyboard, &m_pDIDevice, NULL);
			if(FAILED(Result))
				return 0;

			m_pDIDevice->SetDataFormat( &c_dfDIKeyboard );
			return 1;
		}

		m_pDIDevice->Acquire();
		ZeroMemory(m_uipKeys, sizeof(UINT) * 256);

		HRESULT Result = m_pDIDevice->GetDeviceState(sizeof(UINT) * 256, &m_uipKeys);
	#endif

	return 1;
}