#ifndef MOUSESTATE_H
#define MouseSTATE_H

#pragma once
#include "InputDeviceState.h"

enum eMouseButton
{
	Mouse_LeftButton,
	Mouse_RightButton,
	Mouse_MiddleButton
};

class CMouseState :	public CInputDeviceState
{
	CREATOR(CMouse);

protected:
	CMouseState();
	virtual ~CMouseState();

	UINT Poll();

	tVERTEX2d GetCursorPos();

private:
	tVERTEX2d m_CursorPos;
	tVERTEX2d m_PrevCursorPos;

	tVERTEX2d m_CursorSpeed;

	#ifdef DIRECT_INPUT
		DIMOUSESTATE2 m_MouseState;
	#endif
};

#endif