#ifndef RESOURCE_H
#define RESOURCE_H

#pragma once
#include "Entity.h"

//! Basic Resource class
/*!
	This class serves as a base class for resource-based classes.
*/
class CResource : public CEntity
{
public:

	CResource();
	virtual ~CResource();
	/*!
		Method details:
		This is where all resource clean-up occurs
	*/
	virtual void Destroy() = 0;

	/*!
		Method details:
		This is an implementation of Custom RTTI
	*/
	virtual bool IsOfType(eEntityType eType);
};

#endif