// Define this if you want to use DirectX
// #define DIRECTX	1
// Define this if you want to use OpenGL
#define OPENGL
// #define DIRECT_INPUT

#ifdef DIRECT_INPUT

	#define DIRECTINPUT_VERSION 0x0800

	#include <basetsd.h>
	#include <dinput.h>
	
	#pragma comment (lib, "DXGUID.lib")
	#pragma comment (lib, "DXErr9.lib")
	#pragma comment (lib, "DInput8.lib")
#endif

#ifdef OPENGL
	#ifdef _WIN32
	#include <windows.h>
	#endif

	#include <GL\GL.h>
	#include <GL\GLu.h>
	#include <GL\GLaux.h>

	#pragma comment (lib, "OpenGL32.lib")
	#pragma comment (lib, "GLU32.lib")

#endif