#include "stdafx.h"
#include "Logger.h"

CGlobalLogger::CGlobalLogger()
{
	m_iLogLevel = 0;
}

CGlobalLogger::CGlobalLogger(char *strFilename)
{
	CLogger::Open(strFilename, true, false);
}

CGlobalLogger::~CGlobalLogger()
{
	Close();
}

int CGlobalLogger::Open(char *strFilename, bool bKeepOpen)
{
	return CLogger::Open(strFilename, true, false);
}

int CGlobalLogger::Close()
{
	return 0;
}

void CGlobalLogger::SetLogLevel(int iLogLevel)
{
	m_iLogLevel = iLogLevel;
}

int CGlobalLogger::GetLogLevel()
{
	return m_iLogLevel;
}
