#include "LogicalFont.h"

CLogicalFont::CLogicalFont()
{
	m_dwFlags = 
	m_uiFontWeight = 
	m_uiOrientAngle = 
	m_uiEscapeAngle = 
	m_uiFontHeight = 
	m_uiFontWidth = 0;

	m_ulItalic = m_ulUnderline = m_ulStrikeout = false;
	m_ulCharset = ANSI_CHARSET;
	m_ulOutPrecis = OUT_TT_PRECIS;
	m_ulClipPrecis = CLIP_DEFAULT_PRECIS;
	m_ulOQ = ANTIALIASED_QUALITY;
	m_ulFamily = FF_DONTCARE;
	m_ulPitch = DEFAULT_PITCH;

	SetName(CString("Times New Roman"));
}

int CLogicalFont::LoadXML(TiXmlNode *DataNode, CString Filename)
{

	return 0;
}

int CLogicalFont::SaveXML(TiXmlNode *DataNode, CString Filename)
{

	return 0;
}

int CLogicalFont::CreateFont(HDC hDC, UINT Height, UINT Width, UINT EscapeAngle,
							 UINT OrientAngle, UINT Weight, unsigned long Italic,
							 unsigned long Underline, unsigned long Strikeout, 
							 unsigned long Charset, unsigned long OutputPrec, 
							 unsigned long ClipPrec, unsigned long OutputQual, 
							 unsigned long Family, unsigned long Pitch, 
							 CString FontName, UINT Letters)
{

	m_uiNumLists = Letters;
	m_uiFontBase = glGenLists(m_uiNumLists);			// Storage For 96 Characters

	m_uiFontHeight = Height; m_uiFontWidth = Width; m_uiEscapeAngle = EscapeAngle;
	m_uiOrientAngle = OrientAngle; m_uiFontWeight = Weight;
	m_ulItalic = Italic; m_ulUnderline = Underline; m_ulStrikeout = Strikeout;
	m_ulCharset = Charset; m_ulOutPrecis = OutputPrec;
	m_ulClipPrecis = ClipPrec; m_ulOQ = OutputQual; m_ulFamily = Family; m_ulPitch = Pitch;

	SetName(FontName);

	m_hFont = ::CreateFont(	m_uiFontHeight,
		m_uiFontWidth, 
		m_uiEscapeAngle,
		m_uiOrientAngle,
		m_uiFontWeight,
		m_ulItalic,
		m_ulUnderline,
		m_ulStrikeout,
		m_ulCharset,
		m_ulOutPrecis,
		m_ulClipPrecis,
		m_ulOQ,
		m_ulFamily | m_ulPitch,
		GetName());

	if(m_hFont == NULL)
		return 0;

	m_hOldFont = (HFONT)SelectObject(hDC, m_hFont);
	wglUseFontBitmaps(hDC, 32, m_uiNumLists, m_uiFontBase);		// Builds 96 Characters Starting At Character 32
	SelectObject(hDC, m_hOldFont);								// Selects The Font We Want
	DeleteObject(m_hFont);										// Delete The Font

	return 1;
}

void CLogicalFont::Draw(CString Format, ...)
{

}

void CLogicalFont::DrawChar(float x, float y, char c)
{

}

void CLogicalFont::Destroy()
{
	
}


